// GENERATED BY MITOSIS

import { isJsScript } from "./helpers";
import {
  Fragment,
  component$,
  h,
  useRef,
  useStore,
  useWatch$,
} from "@builder.io/qwik";
export const findAndRunScripts = function findAndRunScripts(
  props,
  state,
  elem
) {
  const scripts = elem.getElementsByTagName("script");

  for (let i = 0; i < scripts.length; i++) {
    const script = scripts[i];

    if (script.src && !state.scriptsInserted.includes(script.src)) {
      state.scriptsInserted.push(script.src);
      const newScript = document.createElement("script");
      newScript.async = true;
      newScript.src = script.src;
      document.head.appendChild(newScript);
    } else if (
      isJsScript(script) &&
      !state.scriptsRun.includes(script.innerText)
    ) {
      try {
        state.scriptsRun.push(script.innerText);
        new Function(script.innerText)();
      } catch (error) {
        console.warn("`Embed`: Error running script:", error);
      }
    }
  }
};
export const Embed = component$((props) => {
  const elem = useRef();
  const state = useStore({
    ranInitFn: false,
    scriptsInserted: [],
    scriptsRun: [],
  });
  useWatch$(({ track }) => {
    state && track(state, "ranInitFn");
    if (elem && !state.ranInitFn) {
      state.ranInitFn = true;
      findAndRunScripts(props, state, elem);
    }
  });
  return (
    <div
      class="builder-embed"
      ref={elem}
      dangerouslySetInnerHTML={props.content}
    ></div>
  );
});
export default Embed;
