// GENERATED BY MITOSIS

import { getSrcSet } from "./image.helpers";
import {
  Fragment,
  Slot,
  component$,
  h,
  useStylesScoped$,
} from "@builder.io/qwik";
export const srcSetToUse = function srcSetToUse(props, state) {
  const imageToUse = props.image || props.src;
  const url = imageToUse;

  if (
    !url || // We can auto add srcset for cdn.builder.io and shopify
    // images, otherwise you can supply this prop manually
    !(url.match(/builder\.io/) || url.match(/cdn\.shopify\.com/))
  ) {
    return props.srcset;
  }

  if (props.srcset && props.image?.includes("builder.io/api/v1/image")) {
    if (!props.srcset.includes(props.image.split("?")[0])) {
      console.debug("Removed given srcset");
      return getSrcSet(url);
    }
  } else if (props.image && !props.srcset) {
    return getSrcSet(url);
  }

  return getSrcSet(url);
};
export const webpSrcSet = function webpSrcSet(props, state) {
  if (srcSetToUse(props, state)?.match(/builder\.io/) && !props.noWebp) {
    return srcSetToUse(props, state).replace(/\?/g, "?format=webp&");
  } else {
    return "";
  }
};
export const Image = component$((props) => {
  useStylesScoped$(STYLES);
  const state = {};
  return (
    <div class="div-Image">
      <picture>
        {webpSrcSet(props, state) ? (
          <source type="image/webp" srcset={webpSrcSet(props, state)}></source>
        ) : null}
        <img
          loading="lazy"
          alt={props.altText}
          role={props.altText ? "presentation" : undefined}
          style={{
            objectPosition: props.backgroundSize || "center",
            objectFit: props.backgroundSize || "cover",
          }}
          class={
            "builder-image" +
            (props.className ? " " + props.className : "") +
            " img-Image"
          }
          src={props.image}
          srcset={srcSetToUse(props, state)}
          sizes={props.sizes}
        ></img>
        <source srcset={srcSetToUse(props, state)}></source>
      </picture>
      {props.aspectRatio &&
      !(props.fitContent && props.builderBlock?.children?.length) ? (
        <div
          class="builder-image-sizer div-Image-2"
          style={{
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            paddingTop: props.aspectRatio * 100 + "%",
          }}
        ></div>
      ) : null}
      {props.builderBlock?.children?.length && props.fitContent ? (
        <Slot></Slot>
      ) : null}
      {!props.fitContent ? (
        <div class="div-Image-3">
          <Slot></Slot>
        </div>
      ) : null}
    </div>
  );
});
export default Image;
export const STYLES = `.div-Image { 
position: relative; }.img-Image { 
opacity: 1;
transition: opacity 0.2s ease-in-out;
position: absolute;
height: 100%;
width: 100%;
top: 0px;
left: 0px; }.div-Image-2 { 
width: 100%;
pointer-events: none;
font-size: 0; }.div-Image-3 { 
display: flex;
flex-direction: column;
align-items: stretch;
position: absolute;
top: 0;
left: 0;
width: 100%;
height: 100%; }`;
