// GENERATED BY MITOSIS

import RenderContent from "../../components/render-content/render-content";
import BuilderContext from "../../context/builder.context";
import { getContent } from "../../functions/get-content/index.js";
import { markMutable } from "../../functions/mark-mutable";
import {
  Fragment,
  component$,
  h,
  useClientEffect$,
  useContext,
  useStore,
  useWatch$,
} from "@builder.io/qwik";
export const Symbol = component$((props) => {
  const builderContext = useContext(BuilderContext);
  const state = useStore({ className: "builder-symbol", content: null });
  useClientEffect$(() => {
    state.content = props.symbol?.content;
  });
  useWatch$(({ track }) => {
    props && track(props, "symbol");
    state && track(state, "content");
    const symbolToUse = props.symbol;
    /**
     * If:
     * - we have a symbol prop
     * - yet it does not have any content
     * - and we have not already stored content from before
     * - and it has a model name
     *
     * then we want to re-fetch the symbol content.
     */

    if (
      symbolToUse &&
      !symbolToUse.content &&
      !state.content &&
      symbolToUse.model
    ) {
      getContent({
        model: symbolToUse.model,
        apiKey: builderContext.apiKey,
        query: {
          id: symbolToUse.entry,
        },
      }).then((response) => {
        state.content = response;
      });
    }
  });
  return (
    <div
      {...props.attributes}
      dataSet={{
        class: state.className,
      }}
      class={state.className}
    >
      <RenderContent
        apiKey={builderContext.apiKey}
        context={builderContext.context}
        customComponents={markMutable(
          Object.values(builderContext.registeredComponents)
        )}
        data={markMutable({
          ...props.symbol?.data,
          ...builderContext.state,
          ...props.symbol?.content?.data?.state,
        })}
        model={props.symbol?.model}
        content={markMutable(state.content)}
      ></RenderContent>
    </div>
  );
});
export default Symbol;
