// GENERATED BY MITOSIS

import { getMaxWidthQueryForSize } from "../../constants/device-sizes.js";
import { TARGET } from "../../constants/target.js";
import { getProcessedBlock } from "../../functions/get-processed-block.js";
import { convertStyleMaptoCSS } from "../../helpers/css.js";
import RenderInlinedStyles from "../render-inlined-styles";
import { Fragment, h } from "@builder.io/qwik";
export const useBlock = function useBlock(props, state) {
  return getProcessedBlock({
    block: props.block,
    state: props.context.state,
    context: props.context.context,
    shouldEvaluateBindings: true,
  });
};
export const css = function css(props, state) {
  const styles = useBlock(props, state).responsiveStyles;
  const largeStyles = styles?.large;
  const mediumStyles = styles?.medium;
  const smallStyles = styles?.small;
  return `
        ${
          largeStyles
            ? `.${useBlock(props, state).id} {${convertStyleMaptoCSS(
                largeStyles
              )}}`
            : ""
        }
        ${
          mediumStyles
            ? `${getMaxWidthQueryForSize("medium")} {
              .${useBlock(props, state).id} {${convertStyleMaptoCSS(
                mediumStyles
              )}}
            }`
            : ""
        }
        ${
          smallStyles
            ? `${getMaxWidthQueryForSize("small")} {
              .${useBlock(props, state).id} {${convertStyleMaptoCSS(
                smallStyles
              )}}
            }`
            : ""
        }
      }`;
};
export const BlockStyles = (props) => {
  const state = {};
  return (
    <>
      {TARGET === "vue2" || TARGET === "vue3" || TARGET === "svelte" ? (
        <RenderInlinedStyles styles={css(props, state)}></RenderInlinedStyles>
      ) : null}
    </>
  );
};
export default BlockStyles;
