import { evaluate } from "./evaluate.js";
import { getEventHandlerName } from "./event-handler-name.js";
function getBlockActions(options) {
  var _a;
  const obj = {};
  const optionActions = (_a = options.block.actions) != null ? _a : {};
  for (const key in optionActions) {
    if (!optionActions.hasOwnProperty(key)) {
      continue;
    }
    const value = optionActions[key];
    obj[getEventHandlerName(key)] = (event) => evaluate({
      code: value,
      context: options.context,
      state: options.state,
      event
    });
  }
  return obj;
}
export {
  getBlockActions
};
