var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { TARGET } from "../constants/target.js";
import { getSessionId } from "../helpers/sessionId.js";
import { getVisitorId } from "../helpers/visitorId.js";
import { isBrowser } from "./is-browser.js";
import { isEditing } from "./is-editing.js";
const getTrackingEventData = ({ canTrack }) => {
  if (!canTrack) {
    return { visitorId: void 0, sessionId: void 0 };
  }
  const sessionId = getSessionId({ canTrack });
  const visitorId = getVisitorId({ canTrack });
  return {
    sessionId,
    visitorId
  };
};
const createEvent = (_a) => {
  var _b = _a, {
    type: eventType,
    canTrack,
    orgId,
    contentId
  } = _b, properties = __objRest(_b, [
    "type",
    "canTrack",
    "orgId",
    "contentId"
  ]);
  return {
    type: eventType,
    data: __spreadProps(__spreadValues(__spreadValues({}, properties), getTrackingEventData({ canTrack })), {
      ownerId: orgId,
      contentId
    })
  };
};
function track(eventProps) {
  if (!eventProps.canTrack) {
    return;
  }
  if (isEditing()) {
    return;
  }
  if (!(isBrowser() || TARGET === "reactNative")) {
    return;
  }
  return fetch(`https://builder.io/api/v1/track`, {
    method: "POST",
    body: JSON.stringify({
      events: [createEvent(eventProps)]
    }),
    headers: {
      "content-type": "application/json"
    },
    mode: "cors"
  });
}
export {
  track
};
